// BitmapObj.cpp : implementation file
//

#include "stdafx.h"

#include "IA369J.h"
#include "BitmapObj.h"


#ifdef _DEBUG
#define new DEBUG_NEW
#undef THIS_FILE
static char THIS_FILE[] = __FILE__;
#endif

/////////////////////////////////////////////////////////////////////////////
// CBitmapObj

IMPLEMENT_SERIAL(CBitmapObj,  CRectObj,  VERSIONABLE_SCHEMA | 1)

CBitmapObj::CBitmapObj()
{
	m_hbm = NULL;
	m_cor = BRANCO;
}

CBitmapObj::~CBitmapObj()
{
	Free();
}



/////////////////////////////////////////////////////////////////////////////
// CBitmapObj message handlers

void CBitmapObj::Serialize(CArchive& ar)
{
	CRectObj::Serialize(ar);
	if(ar.IsStoring())
	{
		PICTDESC pd;
		memset(&pd, 0, sizeof(pd));
		pd.cbSizeofstruct = sizeof(pd);
		pd.picType = PICTYPE_BITMAP;
		pd.bmp.hbitmap = m_hbm;

		IPictureDispPtr spPict;
		if(SUCCEEDED(::OleCreatePictureIndirect(&pd, __uuidof(IPictureDisp), FALSE, (void**)&spPict)))
		{
			IPersistStreamPtr spPS = spPict;
			if(spPS)
			{
				IStreamPtr spStream;
				::CreateStreamOnHGlobal(NULL, TRUE, &spStream);
				spPS->Save(spStream, FALSE);
				LARGE_INTEGER org;
				ULARGE_INTEGER size;

				org.QuadPart = 0;
				spStream->Seek(org, STREAM_SEEK_CUR, &size); // Get Stream size
				spStream->Seek(org, STREAM_SEEK_SET, NULL);  // Rewind stream
				char* pBuffer = new char[size.LowPart];
				spStream->Read(pBuffer, size.LowPart, NULL);
				ar << size.LowPart;
				ar.Write(pBuffer, size.LowPart);
				delete[] pBuffer;
			}
		}
	}
	else
	{
		ULONG size;
		ar >> size;
		HGLOBAL hg = ::GlobalAlloc(GMEM_MOVEABLE, size);
		char* pBuffer = (char*)::GlobalLock(hg);
		ar.Read(pBuffer, size);
		::GlobalUnlock(hg);
		IStreamPtr spStream;
		::CreateStreamOnHGlobal(hg, TRUE, &spStream);
		IPicturePtr spPict;

		::OleLoadPicture(spStream, size, FALSE, IID_IPicture, (void**)&spPict);
		Free();
		spPict->get_Handle((OLE_HANDLE*)&m_hbm);
		m_pict = spPict;
	}
}

void CBitmapObj::LoadDefBitmap()
{
	m_hbm = ::LoadBitmap(AfxGetResourceHandle(), MAKEINTRESOURCE(IDB_BMDEF));
	FitToBitmap();
}


void CBitmapObj::Draw(CDC* pDC, BOOL bSelected)
{
	CRectObj::Draw(pDC, FALSE);

	if(m_hbm)
	{
		CRect2 rect;
		GetDrawInfo(rect);

		HDC hmemDC = ::CreateCompatibleDC(pDC->m_hDC);
		HBITMAP holdBM = (HBITMAP)::SelectObject(hmemDC, m_hbm);
		BITMAP bm;
		::GetObject(m_hbm, sizeof(BITMAP), &bm);

		::StretchBlt(
			  pDC->m_hDC,      // handle to destination DC
			  rect.left,		// x-coord of destination upper-left corner
			  rect.top,			// y-coord of destination upper-left corner
			  rect.Width(),		// width of destination rectangle
			  rect.Height(),	// height of destination rectangle
			  hmemDC,			// handle to source DC
			  0,				// x-coord of source upper-left corner
			  0,				// y-coord of source upper-left corner
			  bm.bmWidth,		// width of source rectangle
			  bm.bmHeight,   // height of source rectangle
			  SRCAND       // raster operation code
		);
		
		::SelectObject(hmemDC, holdBM);
		::DeleteDC(hmemDC);
		
		if(bSelected)
		{
			DrawHandles(pDC, rect);
		}
	}
	else
	{
		CRectObj::Draw(pDC, bSelected);
	}
}


BOOL CBitmapObj::LoadFile(LPCTSTR filename)
{
	CString fn;
	if(filename == NULL)
	{
		CFileDialog fd(TRUE, _T("bmp"), NULL, OFN_HIDEREADONLY | OFN_OVERWRITEPROMPT, _T("Bitmap Files (*.bmp)|*.bmp||"));
		if(fd.DoModal() == IDOK)
		{
			fn = fd.GetPathName();
		}
		else
		{
			return FALSE;
		}
	}
	else
	{
		fn = filename;
	}
	
	IDispatchPtr spDisp;
	if(SUCCEEDED(::OleLoadPictureFile(COleVariant(fn), &spDisp)))
	{
		Free();
		m_pict = spDisp;
		m_pict->get_Handle((OLE_HANDLE*)&m_hbm);
		FitToBitmap();
		return TRUE;
	}
	return FALSE;
}

void CBitmapObj::FitToBitmap()
{
	BITMAP bm;
	if(m_hbm && ::GetObject(m_hbm, sizeof(BITMAP), &bm))
	{
		m_rect = CRect2(CSize(bm.bmWidth, bm.bmHeight));
	}
}
