// GraphObj.cpp : implementation file
//

#include "stdafx.h"
#include "IA369J.h"
#include "GraphObj.h"

#ifdef _DEBUG
#define new DEBUG_NEW
#undef THIS_FILE
static char THIS_FILE[] = __FILE__;
#endif



/////////////////////////////////////////////////////////////////////////////
// CGraphObj

CPoint	CGraphObj::m_ptDragOrg;
CPoint	CGraphObj::m_ptDragNow;


IMPLEMENT_DYNAMIC(CGraphObj, CObject)


CGraphObj::CGraphObj() : m_ptRef(0,0)
{
	m_cor = RGB(0,0,0);
	m_zorder = 0;
	m_deleted = FALSE;
	m_ptDragOrg = m_ptDragNow = CPoint(0, 0);
}	

CGraphObj::~CGraphObj()
{
}

void CGraphObj::TestHandle(POINT& pt, POINT& pt_handle, DWORD& result)
{
	CRect rectHandle(pt_handle, pt_handle);
	rectHandle.InflateRect(CSize(HANDLE_SIZE, HANDLE_SIZE));
	if(rectHandle.PtInRect(pt))
	{
		result |= PTTEST_HANDLE;
	}
}

void CGraphObj::Serialize(CArchive& ar)
{
	ASSERT(!m_deleted);
	CObject::Serialize(ar);
	if(ar.IsStoring())
	{
		ar << m_cor;
		ar << m_zorder;
		ar << m_ptRef;
	}
	else
	{
		ar >> m_cor;
		ar >> m_zorder;
		ar >> m_ptRef;
	}
}

void CGraphObj::Move(POINT& ptNewPos, CRect* rectChanged)
{
	CRect rectInit;
	Bound_rectangle(rectInit);
	m_ptRef += ptNewPos;
	if(rectChanged)
	{
		CRect rectFinal;
		Bound_rectangle(rectFinal);
		*rectChanged = rectInit | rectFinal;
	}
}

void CGraphObj::Move(SIZE& sz, CRect* rectChanged)
{
	Move(m_ptRef + sz, rectChanged);
}

CGraphObj* CGraphObj::Clone(POINT* pPtRef)
{
	CMemFile mf;
	CArchive ars(&mf, CArchive::store);
	ars << this;
	ars.Close();

	mf.Seek(0, CFile::begin);
	CArchive arl(&mf, CArchive::load);
	CObject* pRet;
	arl >> pRet;
	CGraphObj* pObj = reinterpret_cast<CGraphObj*>(pRet);
	if(pPtRef)
	{
		pObj->m_ptRef = *pPtRef;
	}

	return pObj;
}

void CGraphObj::DrawHandle(CDC* pDC, CPoint pt)
{
	CRect rect(pt, pt);
	rect.InflateRect(HANDLE_SIZE, HANDLE_SIZE);
	CPen* pPen = CPen::FromHandle((HPEN)GetStockObject(BLACK_PEN));
	CBrush* pBrush = CBrush::FromHandle((HBRUSH)GetStockObject(NULL_BRUSH));

	CPen* pOldPen = (CPen*)pDC->SelectObject(pPen);
	CBrush* pOldBrush = (CBrush*)pDC->SelectObject(pBrush);

	pDC->Rectangle(&rect);

	pDC->SelectObject(pOldPen);
	pDC->SelectObject(pOldBrush);
}


BOOL CGraphObj::SetColor(COLORREF cor, CRect& rect)
{
	if(cor == m_cor)
	{
		return FALSE;
	}
	m_cor = cor;
	Bound_rectangle(rect);
	return TRUE;
}

BOOL CGraphObj::IsSameSide(POINT& ptA, POINT& ptB, POINT& pt1, POINT& pt2)
{
	int a = ptB.y - ptA.y;
	int b = ptA.x - ptB.x;
	int c = ptB.x*ptA.y - ptB.y*ptA.x;

	int e1 = a*pt1.x + b*pt1.y + c;
	int e2 = a*pt2.x + b*pt2.y + c;

	return e1*e2 >= 0;
}
