// IA369JDoc.h : interface of the CIA369JDoc class
//
/////////////////////////////////////////////////////////////////////////////

#if !defined(AFX_IA369JDOC_H__D64F1FB2_B919_4293_AD52_EE80AE372CB2__INCLUDED_)
#define AFX_IA369JDOC_H__D64F1FB2_B919_4293_AD52_EE80AE372CB2__INCLUDED_

#if _MSC_VER > 1000
#pragma once
#endif // _MSC_VER > 1000


class CCircleObj;
class CLineObj;
class CRectObj;
class CTriangObj;
class CBitmapObj;
class CGraphObj;

class CIA369JDoc : public CDocument
{
public:
	CIA369JDoc();
	virtual ~CIA369JDoc();

// Attributes
protected:
	CCircleObj* m_pDefCircle;
	CLineObj*	m_pDefLine;
	CRectObj*	m_pDefRect;
	CTriangObj* m_pDefTriang;
	COLORREF	m_bkColor;

	CTypedPtrList<CObList, CGraphObj*> m_objList;
	
// Overrides
	// ClassWizard generated virtual function overrides
	//{{AFX_VIRTUAL(CIA369JDoc)
	public:
	virtual BOOL OnNewDocument();
	virtual void Serialize(CArchive& ar);
	virtual void DeleteContents();
	//}}AFX_VIRTUAL


// Operations
public:
	void Draw(CDC* pdc, CGraphObj* pSelObj = NULL);
	CGraphObj* AddNewLine(POINT& ptRef);
	CGraphObj* AddNewCircle(POINT& ptRef);
	CGraphObj* AddNewTriangle(POINT& ptRef);
	CGraphObj* AddNewRectangle(POINT& ptRef);
	CGraphObj* AddNewBitmap(POINT& ptRef);
	CGraphObj* FromPoint(POINT& pt);
	COLORREF   GetBkColor() { return m_bkColor; }
	void       SetBkColor(COLORREF cr) { m_bkColor = cr; }

	POSITION GetTopPosition() { return m_objList.GetHeadPosition();}
	POSITION GetBottomPosition() { return m_objList.GetTailPosition();}
	CGraphObj* GetUpperObj(POSITION& pos) { return m_objList.GetPrev(pos); }
	CGraphObj* GetLowerObj(POSITION& pos) { return m_objList.GetNext(pos); }
	void Delete(CGraphObj* pObj);

	// Generated message map functions
	//{{AFX_MSG(CIA369JDoc)
	afx_msg void OnUpdateFileSave(CCmdUI* pCmdUI);
	//}}AFX_MSG

// Implementation
public:
	void Move_top(CGraphObj* pObj);
	void Move_bottom(CGraphObj* pObj);
	BOOL IsTop(CGraphObj* pObj);
	BOOL IsBottom(CGraphObj* pObj);

#ifdef _DEBUG
	virtual void AssertValid() const;
	virtual void Dump(CDumpContext& dc) const;
#endif

protected:

	DECLARE_DYNCREATE(CIA369JDoc)
	DECLARE_MESSAGE_MAP()
};

/////////////////////////////////////////////////////////////////////////////

//{{AFX_INSERT_LOCATION}}
// Microsoft Visual C++ will insert additional declarations immediately before the previous line.

#endif // !defined(AFX_IA369JDOC_H__D64F1FB2_B919_4293_AD52_EE80AE372CB2__INCLUDED_)
