// IA369JView.cpp : implementation of the CIA369JView class
//

#include "stdafx.h"
#include "IA369J.h"

#include "GraphObj.h"
#include "IA369JDoc.h"
#include "IA369JView.h"
#include "BitmapObj.h"

#ifdef _DEBUG
#define new DEBUG_NEW
#undef THIS_FILE
static char THIS_FILE[] = __FILE__;
#endif

/////////////////////////////////////////////////////////////////////////////
// CIA369JView

IMPLEMENT_DYNCREATE(CIA369JView, CScrollView)

BEGIN_MESSAGE_MAP(CIA369JView, CScrollView)
	//{{AFX_MSG_MAP(CIA369JView)
	ON_COMMAND(ID_FERRAMENTAS_CRCULO, OnFerramentasCrculo)
	ON_COMMAND(ID_FERRAMENTAS_LINHA, OnFerramentasLinha)
	ON_COMMAND(ID_FERRAMENTAS_RETNGULO, OnFerramentasRetngulo)
	ON_COMMAND(ID_FERRAMENTAS_TRINGULO, OnFerramentasTringulo)
	ON_WM_SETCURSOR()
	ON_WM_LBUTTONDOWN()
	ON_WM_LBUTTONUP()
	ON_WM_MOUSEMOVE()
	ON_COMMAND(ID_CORES_VERMELHO, OnCoresVermelho)
	ON_COMMAND(ID_CORES_AMARELO, OnCoresAmarelo)
	ON_COMMAND(ID_CORES_AZUL, OnCoresAzul)
	ON_COMMAND(ID_CORES_PRETO, OnCoresPreto)
	ON_COMMAND(ID_CORES_VERDE, OnCoresVerde)
	ON_UPDATE_COMMAND_UI(ID_CORES_AMARELO, OnUpdateCoresAmarelo)
	ON_UPDATE_COMMAND_UI(ID_CORES_AZUL, OnUpdateCoresAzul)
	ON_UPDATE_COMMAND_UI(ID_CORES_PRETO, OnUpdateCoresPreto)
	ON_UPDATE_COMMAND_UI(ID_CORES_VERDE, OnUpdateCoresVerde)
	ON_UPDATE_COMMAND_UI(ID_CORES_VERMELHO, OnUpdateCoresVermelho)
	ON_COMMAND(ID_CORES_MAGENTA, OnCoresMagenta)
	ON_UPDATE_COMMAND_UI(ID_CORES_MAGENTA, OnUpdateCoresMagenta)
	ON_COMMAND(ID_CORES_CYAN, OnCoresCyan)
	ON_UPDATE_COMMAND_UI(ID_CORES_CYAN, OnUpdateCoresCyan)
	ON_COMMAND(ID_EDITAR_REMOVER, OnEditarRemover)
	ON_UPDATE_COMMAND_UI(ID_EDITAR_REMOVER, OnUpdateEditarRemover)
	ON_WM_CONTEXTMENU()
	ON_COMMAND(ID_OBJCTX_MOVEPARABAIXO, OnObjctxMoveparabaixo)
	ON_UPDATE_COMMAND_UI(ID_OBJCTX_MOVEPARABAIXO, OnUpdateObjctxMoveparabaixo)
	ON_COMMAND(ID_OBJCTX_MOVEPARAOTOPO, OnObjctxMoveparaotopo)
	ON_UPDATE_COMMAND_UI(ID_OBJCTX_MOVEPARAOTOPO, OnUpdateObjctxMoveparaotopo)
	ON_COMMAND(ID_FERRAMENTAS_BITMAP, OnFerramentasBitmap)
	ON_COMMAND(ID_OBJCTX_CARREGABITMAP, OnObjctxCarregabitmap)
	ON_UPDATE_COMMAND_UI(ID_OBJCTX_CARREGABITMAP, OnUpdateObjctxCarregabitmap)
	ON_WM_ERASEBKGND()
	ON_COMMAND(ID_CORES_BRANCO, OnCoresBranco)
	ON_COMMAND(ID_CORES_CINZA, OnCoresCinza)
	ON_UPDATE_COMMAND_UI(ID_CORES_CINZA, OnUpdateCoresCinza)
	ON_UPDATE_COMMAND_UI(ID_CORES_BRANCO, OnUpdateCoresBranco)
	//}}AFX_MSG_MAP
END_MESSAGE_MAP()

/////////////////////////////////////////////////////////////////////////////
// CIA369JView construction/destruction

CIA369JView::CIA369JView()
{
	m_pSelectedObj = NULL;
	m_hcurHandle = AfxGetApp()->LoadCursor(IDC_CURSOR_HANDLER);
	m_hcurOnObj = AfxGetApp()->LoadCursor(IDC_CURSOR_ONOBJ);
}

CIA369JView::~CIA369JView()
{
}

BOOL CIA369JView::PreCreateWindow(CREATESTRUCT& cs)
{
	// TODO: Modify the Window class or styles here by modifying
	//  the CREATESTRUCT cs

	return CScrollView::PreCreateWindow(cs);
}

/////////////////////////////////////////////////////////////////////////////
// CIA369JView drawing

void CIA369JView::OnDraw(CDC* pDC)
{
	CIA369JDoc* pDoc = GetDocument();
	ASSERT_VALID(pDoc);
	pDoc->Draw(pDC, m_pSelectedObj);
}

void CIA369JView::OnInitialUpdate()
{
	CScrollView::OnInitialUpdate();

	CSize sizeTotal;
	// TODO: calculate the total size of this view
	sizeTotal.cx = sizeTotal.cy = 1000;
	SetScrollSizes(MM_TEXT, sizeTotal);
}

/////////////////////////////////////////////////////////////////////////////
// CIA369JView diagnostics

#ifdef _DEBUG
void CIA369JView::AssertValid() const
{
	CScrollView::AssertValid();
}

void CIA369JView::Dump(CDumpContext& dc) const
{
	CScrollView::Dump(dc);
}

CIA369JDoc* CIA369JView::GetDocument() // non-debug version is inline
{
	ASSERT(m_pDocument->IsKindOf(RUNTIME_CLASS(CIA369JDoc)));
	return (CIA369JDoc*)m_pDocument;
}
#endif //_DEBUG

/////////////////////////////////////////////////////////////////////////////
// CIA369JView message handlers

void CIA369JView::OnFerramentasCrculo() 
{
	CRect rect;
	GetClientRect(&rect);
	CPoint ptRef = rect.TopLeft();
	CClientDC dc(this);
	OnPrepareDC(&dc);
	dc.DPtoLP(&ptRef);

	CIA369JDoc* pDoc = GetDocument();
	Select(pDoc->AddNewCircle(ptRef));
	pDoc->SetModifiedFlag();
}

void CIA369JView::OnFerramentasLinha() 
{
	CRect rect;
	GetClientRect(&rect);
	CPoint ptRef = rect.TopLeft();
	CClientDC dc(this);
	OnPrepareDC(&dc);
	dc.DPtoLP(&ptRef);

	CIA369JDoc* pDoc = GetDocument();
	Select(pDoc->AddNewLine(ptRef));
	pDoc->SetModifiedFlag();
}


void CIA369JView::OnFerramentasRetngulo() 
{
	CRect rect;
	GetClientRect(&rect);
	CPoint ptRef = rect.TopLeft();
	CClientDC dc(this);
	OnPrepareDC(&dc);
	dc.DPtoLP(&ptRef);

	CIA369JDoc* pDoc = GetDocument();
	Select(pDoc->AddNewRectangle(ptRef));
	pDoc->SetModifiedFlag();
}


void CIA369JView::OnFerramentasTringulo() 
{
	CRect rect;
	GetClientRect(&rect);
	CPoint ptRef = rect.TopLeft();
	CClientDC dc(this);
	OnPrepareDC(&dc);
	dc.DPtoLP(&ptRef);

	CIA369JDoc* pDoc = GetDocument();
	Select(pDoc->AddNewTriangle(ptRef));
	pDoc->SetModifiedFlag();
}



BOOL CIA369JView::OnSetCursor(CWnd* pWnd, UINT nHitTest, UINT message) 
{
	if(pWnd == this)
	{
		CIA369JDoc* pDoc = GetDocument();
		DWORD  dwPos = GetMessagePos();
		CPoint pt(dwPos);
		ScreenToClient(&pt);
		CClientDC dc(this);
		OnPrepareDC(&dc);
		dc.DPtoLP(&pt);

		if(m_pSelectedObj != NULL)
		{
			DWORD dwtest = m_pSelectedObj->Test_point(pt);

			if(dwtest & PTTEST_HANDLE)
			{
				SetCursor(m_hcurHandle);
				return TRUE;
			}
		}

		if(pDoc->FromPoint(pt))
		{
			SetCursor(m_hcurOnObj);
			return TRUE;
		}
	}
	
	return CScrollView::OnSetCursor(pWnd, nHitTest, message);
}

void CIA369JView::OnLButtonDown(UINT nFlags, CPoint point) 
{
	CPoint lpt(point);
	CClientDC dc(this);
	OnPrepareDC(&dc);
	dc.DPtoLP(&lpt);
	if(m_pSelectedObj)
	{
		if(m_pSelectedObj->Grab_point(lpt, TRUE))
		{
			SetCapture();
			return;
		}
	}
	

	CIA369JDoc* pDoc = GetDocument();
	POSITION pos = pDoc->GetTopPosition();
	while(pos)
	{
		CGraphObj* pObj = pDoc->GetLowerObj(pos);
		if(pObj->Grab_point(lpt, FALSE))
		{
			Select(pObj);
			SetCapture();
			return;
		}
	}

	Select(NULL);

//	CScrollView::OnLButtonDown(nFlags, point);
}

void CIA369JView::Select(CGraphObj* pObj)
{
	if(m_pSelectedObj == pObj)
	{
		return;
	}
	CClientDC dc(this);
	OnPrepareDC(&dc);
	CRect rect;
	if(m_pSelectedObj)
	{
		m_pSelectedObj->Bound_rectangle(rect);
		dc.LPtoDP(&rect);
		InvalidateRect(&rect);
	}

	m_pSelectedObj = pObj;
	if(m_pSelectedObj)
	{
		m_pSelectedObj->Bound_rectangle(rect);
		dc.LPtoDP(&rect);
		InvalidateRect(&rect);
	}
}


void CIA369JView::OnLButtonUp(UINT nFlags, CPoint point) 
{
	if(m_pSelectedObj)
	{
		CPoint lpt(point);
		CClientDC dc(this);
		OnPrepareDC(&dc);
		dc.DPtoLP(&lpt);
		CRect rect;
		if(m_pSelectedObj->Release_point(lpt, TRUE, &rect))
		{
			dc.LPtoDP(&rect);
			InvalidateRect(&rect);
			ReleaseCapture();
			GetDocument()->SetModifiedFlag();
		}
	}
	
	CScrollView::OnLButtonUp(nFlags, point);
}

void CIA369JView::OnMouseMove(UINT nFlags, CPoint point) 
{
	if(m_pSelectedObj)
	{
		CPoint lpt(point);
		CClientDC dc(this);
		OnPrepareDC(&dc);
		dc.DPtoLP(&lpt);
		CRect rect;
		if(m_pSelectedObj->Move_point(lpt, &rect))
		{
			dc.LPtoDP(&rect);
			InvalidateRect(&rect);
		}
	}
	
	CScrollView::OnMouseMove(nFlags, point);
}

void CIA369JView::ApplyColor(COLORREF cor)
{
	CRect rect;
	CIA369JDoc* pDoc = GetDocument();
	if(m_pSelectedObj) 
	{		// Change object color
		if(m_pSelectedObj->SetColor(cor, rect))
		{
			pDoc->SetModifiedFlag();
			CClientDC dc(this);
			OnPrepareDC(&dc);
			dc.LPtoDP(&rect);
			InvalidateRect(&rect);
		}
	}
	else 
	{		// Change background color
		if(cor != pDoc->GetBkColor())
		{
			pDoc->SetBkColor(cor);
			pDoc->SetModifiedFlag();
			Invalidate();
		}
	}
}

void CIA369JView::UpdateColor(CCmdUI *pCmdUI, COLORREF cor)
{
	if(m_pSelectedObj)
	{
		pCmdUI->Enable(TRUE);
		pCmdUI->SetCheck(cor == m_pSelectedObj->GetColor());

	}
	else
	{
		pCmdUI->SetCheck(cor == GetDocument()->GetBkColor());
	}
}

void CIA369JView::OnCoresVermelho() 
{
	ApplyColor(VERMELHO);
}

void CIA369JView::OnCoresAmarelo() 
{
	ApplyColor(AMARELO);
}

void CIA369JView::OnCoresAzul() 
{
	ApplyColor(AZUL);
}

void CIA369JView::OnCoresPreto() 
{
	ApplyColor(PRETO);
}

void CIA369JView::OnCoresVerde() 
{
	ApplyColor(VERDE);
}


void CIA369JView::OnCoresMagenta() 
{
	ApplyColor(MAGENTA);
}

void CIA369JView::OnCoresCyan() 
{
	ApplyColor(CYAN);
}

void CIA369JView::OnCoresBranco() 
{
	ApplyColor(BRANCO);
}

void CIA369JView::OnCoresCinza() 
{
	ApplyColor(CINZA);
}



void CIA369JView::OnUpdateCoresAmarelo(CCmdUI* pCmdUI) 
{
	UpdateColor(pCmdUI, AMARELO);
}

void CIA369JView::OnUpdateCoresAzul(CCmdUI* pCmdUI) 
{
	UpdateColor(pCmdUI, AZUL);
}

void CIA369JView::OnUpdateCoresPreto(CCmdUI* pCmdUI) 
{
	UpdateColor(pCmdUI, PRETO);
}

void CIA369JView::OnUpdateCoresVerde(CCmdUI* pCmdUI) 
{
	UpdateColor(pCmdUI, VERDE);
}

void CIA369JView::OnUpdateCoresVermelho(CCmdUI* pCmdUI) 
{
	UpdateColor(pCmdUI, VERMELHO);
}

void CIA369JView::OnUpdateCoresMagenta(CCmdUI* pCmdUI) 
{
	UpdateColor(pCmdUI, MAGENTA);
}

void CIA369JView::OnUpdateCoresCyan(CCmdUI* pCmdUI) 
{
	UpdateColor(pCmdUI, CYAN);
}

void CIA369JView::OnUpdateCoresCinza(CCmdUI* pCmdUI) 
{
	UpdateColor(pCmdUI, CINZA);
}

void CIA369JView::OnUpdateCoresBranco(CCmdUI* pCmdUI) 
{
	UpdateColor(pCmdUI, BRANCO);
}

void CIA369JView::OnUpdate(CView* pSender, LPARAM lHint, CObject* pHint) 
{
	if(m_pSelectedObj)
	{
		CIA369JDoc* pDoc = GetDocument();
		POSITION pos = pDoc->GetTopPosition();
		while(pos)
		{
			if(m_pSelectedObj == pDoc->GetLowerObj(pos))
			{
				return;
			}
		}
		m_pSelectedObj = NULL;
	}
	CView::OnUpdate(pSender, lHint, pHint);
}

void CIA369JView::OnEditarRemover() 
{
	if(m_pSelectedObj)
	{
		CClientDC dc(this);
		OnPrepareDC(&dc);

		CRect rect;
		m_pSelectedObj->Bound_rectangle(rect);
		dc.LPtoDP(&rect);

		GetDocument()->Delete(m_pSelectedObj);
		m_pSelectedObj = NULL;
		InvalidateRect(&rect);
	}
}

void CIA369JView::OnUpdateEditarRemover(CCmdUI* pCmdUI) 
{
	pCmdUI->Enable(m_pSelectedObj != NULL);
}

void CIA369JView::OnContextMenu(CWnd* pWnd, CPoint point) 
{
	CIA369JDoc* pDoc = GetDocument();
	CFrameWnd* pParent = GetParentFrame();
	CClientDC dc(this);
	OnPrepareDC(&dc);

	CPoint ptClient(point);
	ScreenToClient(&ptClient);

	CPoint ptDoc(ptClient);
	dc.DPtoLP(&ptDoc);

	CGraphObj* pObj = pDoc->FromPoint(ptDoc);
	Select(pObj);

	if(pObj)
	{
		CMenu menu;
		menu.LoadMenu(IDR_MENU_OBJ);
		CMenu* pMenu = menu.GetSubMenu(0);

		pMenu->TrackPopupMenu(TPM_LEFTALIGN | TPM_LEFTBUTTON | TPM_RIGHTBUTTON,
			point.x, point.y, pParent);
	}
}

void CIA369JView::OnObjctxMoveparabaixo() 
{
	CIA369JDoc* pDoc = GetDocument();
	pDoc->Move_bottom(m_pSelectedObj);
}

void CIA369JView::OnUpdateObjctxMoveparabaixo(CCmdUI* pCmdUI) 
{
	CIA369JDoc* pDoc = GetDocument();
	pCmdUI->Enable(!pDoc->IsBottom(m_pSelectedObj));
}

void CIA369JView::OnObjctxMoveparaotopo() 
{
	CIA369JDoc* pDoc = GetDocument();
	pDoc->Move_top(m_pSelectedObj);
}

void CIA369JView::OnUpdateObjctxMoveparaotopo(CCmdUI* pCmdUI) 
{
	CIA369JDoc* pDoc = GetDocument();
	pCmdUI->Enable(!pDoc->IsTop(m_pSelectedObj));
}

void CIA369JView::OnFerramentasBitmap() 
{
	CRect rect;
	GetClientRect(&rect);
	CPoint ptRef = rect.TopLeft();
	CClientDC dc(this);
	OnPrepareDC(&dc);
	dc.DPtoLP(&ptRef);

	CIA369JDoc* pDoc = GetDocument();
	Select(pDoc->AddNewBitmap(ptRef));
	pDoc->SetModifiedFlag();
}


void CIA369JView::OnObjctxCarregabitmap() 
{
	if(m_pSelectedObj != NULL && m_pSelectedObj->IsKindOf(RUNTIME_CLASS(CBitmapObj)))
	{
		CBitmapObj* pBO = (CBitmapObj*)m_pSelectedObj;
		if(pBO->LoadFile())
		{
			Invalidate();
		}
	}
}

void CIA369JView::OnUpdateObjctxCarregabitmap(CCmdUI* pCmdUI) 
{
	pCmdUI->Enable(m_pSelectedObj != NULL && m_pSelectedObj->IsKindOf(RUNTIME_CLASS(CBitmapObj)));
}

BOOL CIA369JView::OnEraseBkgnd(CDC* pDC) 
{
	return 1;	// No erase
	
	return CScrollView::OnEraseBkgnd(pDC);
}


