// IA369JView.h : interface of the CIA369JView class
//
/////////////////////////////////////////////////////////////////////////////

#if !defined(AFX_IA369JVIEW_H__91AA6C1B_5528_44AF_8E9E_F4E9DAEE4602__INCLUDED_)
#define AFX_IA369JVIEW_H__91AA6C1B_5528_44AF_8E9E_F4E9DAEE4602__INCLUDED_

#if _MSC_VER > 1000
#pragma once
#endif // _MSC_VER > 1000

class CIA369JView : public CScrollView
{
protected: // create from serialization only
	CIA369JView();
	DECLARE_DYNCREATE(CIA369JView)

// Attributes
public:
	CIA369JDoc* GetDocument();


protected:
	CGraphObj* m_pSelectedObj;
	HCURSOR m_hcurHandle;
	HCURSOR m_hcurOnObj;

// Operations
public:
	void Select(CGraphObj* pObj);
// Overrides
	// ClassWizard generated virtual function overrides
	//{{AFX_VIRTUAL(CIA369JView)
	public:
	virtual void OnDraw(CDC* pDC);  // overridden to draw this view
	virtual BOOL PreCreateWindow(CREATESTRUCT& cs);
	protected:
	virtual void OnInitialUpdate(); // called first time after construct
	virtual void OnUpdate(CView* pSender, LPARAM lHint, CObject* pHint);
	//}}AFX_VIRTUAL

// Implementation
public:
	virtual ~CIA369JView();
#ifdef _DEBUG
	virtual void AssertValid() const;
	virtual void Dump(CDumpContext& dc) const;
#endif

protected:

// Generated message map functions
protected:
	void UpdateColor(CCmdUI* pCmdUI, COLORREF cor);
	void ApplyColor(COLORREF cor);
	//{{AFX_MSG(CIA369JView)
	afx_msg void OnFerramentasCrculo();
	afx_msg void OnFerramentasLinha();
	afx_msg void OnFerramentasRetngulo();
	afx_msg void OnFerramentasTringulo();
	afx_msg BOOL OnSetCursor(CWnd* pWnd, UINT nHitTest, UINT message);
	afx_msg void OnLButtonDown(UINT nFlags, CPoint point);
	afx_msg void OnLButtonUp(UINT nFlags, CPoint point);
	afx_msg void OnMouseMove(UINT nFlags, CPoint point);
	afx_msg void OnCoresVermelho();
	afx_msg void OnCoresAmarelo();
	afx_msg void OnCoresAzul();
	afx_msg void OnCoresPreto();
	afx_msg void OnCoresVerde();
	afx_msg void OnUpdateCoresAmarelo(CCmdUI* pCmdUI);
	afx_msg void OnUpdateCoresAzul(CCmdUI* pCmdUI);
	afx_msg void OnUpdateCoresPreto(CCmdUI* pCmdUI);
	afx_msg void OnUpdateCoresVerde(CCmdUI* pCmdUI);
	afx_msg void OnUpdateCoresVermelho(CCmdUI* pCmdUI);
	afx_msg void OnCoresMagenta();
	afx_msg void OnUpdateCoresMagenta(CCmdUI* pCmdUI);
	afx_msg void OnCoresCyan();
	afx_msg void OnUpdateCoresCyan(CCmdUI* pCmdUI);
	afx_msg void OnEditarRemover();
	afx_msg void OnUpdateEditarRemover(CCmdUI* pCmdUI);
	afx_msg void OnContextMenu(CWnd* pWnd, CPoint point);
	afx_msg void OnObjctxMoveparabaixo();
	afx_msg void OnUpdateObjctxMoveparabaixo(CCmdUI* pCmdUI);
	afx_msg void OnObjctxMoveparaotopo();
	afx_msg void OnUpdateObjctxMoveparaotopo(CCmdUI* pCmdUI);
	afx_msg void OnFerramentasBitmap();
	afx_msg void OnObjctxCarregabitmap();
	afx_msg void OnUpdateObjctxCarregabitmap(CCmdUI* pCmdUI);
	afx_msg BOOL OnEraseBkgnd(CDC* pDC);
	afx_msg void OnCoresBranco();
	afx_msg void OnCoresCinza();
	afx_msg void OnUpdateCoresCinza(CCmdUI* pCmdUI);
	afx_msg void OnUpdateCoresBranco(CCmdUI* pCmdUI);
	//}}AFX_MSG
	DECLARE_MESSAGE_MAP()
};

#ifndef _DEBUG  // debug version in IA369JView.cpp
inline CIA369JDoc* CIA369JView::GetDocument()
   { return (CIA369JDoc*)m_pDocument; }
#endif

/////////////////////////////////////////////////////////////////////////////

//{{AFX_INSERT_LOCATION}}
// Microsoft Visual C++ will insert additional declarations immediately before the previous line.

#endif // !defined(AFX_IA369JVIEW_H__91AA6C1B_5528_44AF_8E9E_F4E9DAEE4602__INCLUDED_)
