// RectObj.cpp : implementation file
//

#include "stdafx.h"
#include "IA369J.h"
#include "RectObj.h"

#ifdef _DEBUG
#define new DEBUG_NEW
#undef THIS_FILE
static char THIS_FILE[] = __FILE__;
#endif

/////////////////////////////////////////////////////////////////////////////
// CRectObj

IMPLEMENT_SERIAL(CRectObj,  CGraphObj,  VERSIONABLE_SCHEMA | 1)

CRectObj::CRectObj()
{
	m_dragstat = NODRAG;
	m_rect = CRect(20, 20, 120, 120);
	m_cor = VERDE;
}

CRectObj::~CRectObj()
{
}

void CRectObj::GetDrawInfo(CRect& rect)
{
	rect = m_rect;
	rect.OffsetRect(m_ptRef);

//	enum {NODRAG, DRAGTL, DRAGT, DRAGTR, DRAGR, DRAGBR, DRAGB, DRAGBL, DRAGALL} m_dragstat;
	switch(m_dragstat)
	{
	case DRAGTL:
		rect.top = m_ptDragNow.y;
		rect.left = m_ptDragNow.x;
		break;

	case DRAGT:
		rect.top = m_ptDragNow.y;
		break;

	case DRAGTR:
		rect.top = m_ptDragNow.y;
		rect.right = m_ptDragNow.x;
		break;

	case DRAGR:
		rect.right = m_ptDragNow.x;
		break;

	case DRAGBR:
		rect.bottom = m_ptDragNow.y;
		rect.right = m_ptDragNow.x;
		break;

	case DRAGB:
		rect.bottom = m_ptDragNow.y;
		break;

	case DRAGBL:
		rect.bottom = m_ptDragNow.y;
		rect.left = m_ptDragNow.x;
		break;

	case DRAGL:
		rect.left = m_ptDragNow.x;
		break;

	case DRAGALL:
		rect.OffsetRect(m_ptDragNow - m_ptDragOrg);
		break;

	}

	rect.NormalizeRect();
}


DWORD CRectObj::Test_point(POINT& pt)
{
	CRect2 rect;
	DWORD dwRet = 0;

	GetDrawInfo(rect);

	TestHandle(pt, rect.BottomRight(), dwRet);
	TestHandle(pt, rect.TopLeft(), dwRet);
	TestHandle(pt, rect.TopRight(), dwRet);
	TestHandle(pt, rect.BottomLeft(), dwRet);
	TestHandle(pt, rect.LeftHandle(), dwRet);
	TestHandle(pt, rect.RightHandle(), dwRet);
	TestHandle(pt, rect.TopHandle(), dwRet);
	TestHandle(pt, rect.BottomHandle(), dwRet);

	if(	rect.PtInRect(pt))
	{
		dwRet |= PTTEST_INSIDE;
	}
	return dwRet;
}

void CRectObj::Bound_rectangle(CRect& rect)
{
	GetDrawInfo(rect);
	rect.InflateRect(HANDLE_SIZE+1, HANDLE_SIZE+1);
}

void CRectObj::Draw(CDC* pDC, BOOL bSelected)
{
	CPen  pen(PS_NULL, 0, RGB(0,0,0));
	CBrush brush(m_cor);
	CPen* pOldPen = (CPen*)pDC->SelectObject(&pen);
	CBrush* pOldBrush = (CBrush*)pDC->SelectObject(&brush);

	CRect2 rect;
	GetDrawInfo(rect);

	pDC->Rectangle(&rect);

	pDC->SelectObject(pOldPen);
	pDC->SelectObject(pOldBrush);
	
	if(bSelected)
	{
		DrawHandles(pDC, rect);
	}
}

void CRectObj::DrawHandles(CDC* pDC, CRect2& rect)
{
		DrawHandle(pDC, rect.BottomRight());
		DrawHandle(pDC, rect.TopLeft());
		DrawHandle(pDC, rect.TopRight());
		DrawHandle(pDC, rect.BottomLeft());
		DrawHandle(pDC, rect.LeftHandle());
		DrawHandle(pDC, rect.RightHandle());
		DrawHandle(pDC, rect.TopHandle());
		DrawHandle(pDC, rect.BottomHandle());
}


BOOL CRectObj::Grab_point(POINT& pt, BOOL bSelected)
{
//	enum {NODRAG, DRAGTL, DRAGT, DRAGTR, DRAGR, DRAGBR, DRAGB, DRAGBL, DRAGL, DRAGALL} m_dragstat;

	ASSERT(m_dragstat == NODRAG);
	CRect2 rect;
	GetDrawInfo(rect);
	DWORD dw = 0;
	if(bSelected)
	{
		TestHandle(pt, rect.BottomRight(), dw);
		if(dw)
		{
			m_dragstat = DRAGBR;
			m_ptDragNow = m_ptDragOrg = pt;
			return TRUE;
		}

		TestHandle(pt, rect.TopLeft(), dw);
		if(dw)
		{
			m_dragstat = DRAGTL;
			m_ptDragNow = m_ptDragOrg = pt;
			return TRUE;
		}

		TestHandle(pt, rect.TopRight(), dw);
		if(dw)
		{
			m_dragstat = DRAGTR;
			m_ptDragNow = m_ptDragOrg = pt;
			return TRUE;
		}

		TestHandle(pt, rect.BottomLeft(), dw);
		if(dw)
		{
			m_dragstat = DRAGBL;
			m_ptDragNow = m_ptDragOrg = pt;
			return TRUE;
		}

		TestHandle(pt, rect.LeftHandle(), dw);
		if(dw)
		{
			m_dragstat = DRAGL;
			m_ptDragNow = m_ptDragOrg = pt;
			return TRUE;
		}

		TestHandle(pt, rect.RightHandle(), dw);
		if(dw)
		{
			m_dragstat = DRAGR;
			m_ptDragNow = m_ptDragOrg = pt;
			return TRUE;
		}

		TestHandle(pt, rect.TopHandle(), dw);
		if(dw)
		{
			m_dragstat = DRAGT;
			m_ptDragNow = m_ptDragOrg = pt;
			return TRUE;
		}

		TestHandle(pt, rect.BottomHandle(), dw);
		if(dw)
		{
			m_dragstat = DRAGB;
			m_ptDragNow = m_ptDragOrg = pt;
			return TRUE;
		}
	}
	
	if(	rect.PtInRect(pt))
	{
		m_dragstat = DRAGALL;
		m_ptDragNow = m_ptDragOrg = pt;
		return TRUE;
	}

	return FALSE;
}

BOOL CRectObj::Release_point(POINT& pt, BOOL Success, RECT* pRect)
{
	if(m_dragstat == NODRAG)
	{
		return FALSE;
	}

	CSize szoff(CPoint(pt) - m_ptDragOrg);
	if(Success)
	{
		Move_point(pt, pRect);
		CRect2 rect;
		GetDrawInfo(rect);

//	enum {NODRAG, DRAGTL, DRAGT, DRAGTR, DRAGR, DRAGBR, DRAGB, DRAGBL, DRAGL, DRAGALL} m_dragstat;
		rect.OffsetRect(-m_ptRef);
		m_rect = rect;

		Normalize();
	}
	else
	{
		Move_point(m_ptDragOrg, pRect);
	}
	m_dragstat = NODRAG;
	return TRUE;
}

BOOL CRectObj::Move_point(POINT& pt, RECT* pRect)
{
//	enum {NODRAG, DRAGTL, DRAGT, DRAGTR, DRAGR, DRAGBR, DRAGB, DRAGBL, DRAGL, DRAGALL} m_dragstat;

	if(m_dragstat == NODRAG)
	{
		return FALSE;
	}

	CRect rect1, rect2;
	Bound_rectangle(rect1);
	m_ptDragNow = pt;
	if(pRect)
	{
		Bound_rectangle(rect2);
		*pRect = rect1 | rect2;
	}
	return TRUE;
}

BOOL CRectObj::Show_properties()
{
	return FALSE;
}

void CRectObj::Normalize()
{
	CPoint ptOrg = m_rect.TopLeft();

	m_ptRef += ptOrg;
	m_rect.OffsetRect(-ptOrg);
}

void CRectObj::Serialize(CArchive& ar)
{
	CGraphObj::Serialize(ar);
	if(ar.IsStoring())
	{
		ar << m_rect;
	}
	else
	{
		ar >> m_rect;
	}
}
