#if !defined(AFX_RECTOBJ_H__8E52030F_3BA7_4EC7_92FF_BD0A85E7EC5A__INCLUDED_)
#define AFX_RECTOBJ_H__8E52030F_3BA7_4EC7_92FF_BD0A85E7EC5A__INCLUDED_

#if _MSC_VER > 1000
#pragma once
#endif // _MSC_VER > 1000
// RectObj.h : header file
//

#include "GraphObj.h"


class CRect2 : public CRect
{
public:
	CRect2(CRect& r) : CRect(r) {}
	CRect2() : CRect() {}
	CRect2(SIZE size) : CRect(CPoint(0,0), size) {}

	CPoint TopRight() { return CPoint(right, top);}
	CPoint BottomLeft() { return CPoint(left, bottom); }
	CPoint TopHandle() { return CPoint((left + right)/2, top); }
	CPoint RightHandle() { return CPoint(right, (top + bottom)/2); }
	CPoint LeftHandle() { return CPoint(left, (top + bottom)/2); }
	CPoint BottomHandle() { return CPoint((left + right)/2, bottom); }

};

/////////////////////////////////////////////////////////////////////////////
// CRectObj command target

class CRectObj : public CGraphObj
{
public:

	CRectObj();
	virtual ~CRectObj();

// Attributes
public:

protected:
	enum {NODRAG, DRAGTL, DRAGT, DRAGTR, DRAGR, DRAGBR, DRAGB, DRAGBL, DRAGL, DRAGALL} m_dragstat;
	CRect2 m_rect;
	void	GetDrawInfo(CRect& rect);

	// Operations
public:
	virtual DWORD Test_point(POINT& pt);
	virtual void Bound_rectangle(CRect& rect);
	virtual void Draw(CDC* pDC, BOOL bSelected);
	virtual BOOL Grab_point(POINT& pt, BOOL bSelected);
	virtual BOOL Release_point(POINT& pt, BOOL Success, RECT* pRect = NULL);
	virtual BOOL Move_point(POINT& pt, RECT* pRect = NULL);
	virtual BOOL Show_properties();
	virtual void Normalize();
	virtual void Serialize(CArchive& ar);

	void DrawHandles(CDC* pDC, CRect2& rect);

// Overrides
	// ClassWizard generated virtual function overrides
	//{{AFX_VIRTUAL(CRectObj)
	//}}AFX_VIRTUAL

// Implementation
protected:


	DECLARE_SERIAL(CRectObj)
};

/////////////////////////////////////////////////////////////////////////////

//{{AFX_INSERT_LOCATION}}
// Microsoft Visual C++ will insert additional declarations immediately before the previous line.

#endif // !defined(AFX_RECTOBJ_H__8E52030F_3BA7_4EC7_92FF_BD0A85E7EC5A__INCLUDED_)
